/*
 * THIS FILE IS AUTO-GENERATED. DO NOT EDIT.
 * Generated by codegen.py from validator_x86_32.rl and validator_x86_32.xml.
 */

/*
 * Copyright (c) 2012 The Native Client Authors. All rights reserved.
 * Use of this source code is governed by a BSD-style license that can be
 * found in the LICENSE file.
 */

/*
 * This is the core of ia32-mode validator.  Please note that this file
 * combines ragel machine description and C language actions.  Please read
 * validator_internals.html first to understand how the whole thing is built:
 * it explains how the byte sequences are constructed, what constructs like
 * "@{}" or "REX_WRX?" mean, etc.
 */

#include <assert.h>
#include <errno.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "native_client/src/trusted/validator_ragel/bitmap.h"
#include "native_client/src/trusted/validator_ragel/validator_internal.h"

/* Ignore this information: it's not used by security model in IA32 mode.  */
/* TODO(khim): change gen_dfa to remove needs for these lines.  */
#undef GET_VEX_PREFIX3
#define GET_VEX_PREFIX3 0
#undef SET_VEX_PREFIX3
#define SET_VEX_PREFIX3(PREFIX_BYTE)


/*
 * The "write data" statement causes Ragel to emit the constant static data
 * needed by the ragel machine.
 */
static const int _dfa_accepting[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1};
static const uint16_t _dfa_transitions[][256][2] = {
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {3, 0}, {1, 1}, {1, 1}},
  {{7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}, {7, 2}},
  {{7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}, {7, 3}},
  {{7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}, {7, 4}},
  {{8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}, {8, 5}},
  {{9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}, {9, 5}},
  {{4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}},
  {{3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}},
  {{10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}},
  {{7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}, {7, 6}},
  {{7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}, {7, 7}},
  {{7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}, {7, 8}},
  {{11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}, {11, 5}},
  {{0, 0}, {12, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {0, 0}, {13, 0}, {14, 9}, {15, 0}, {16, 0}, {16, 0}, {16, 0}, {17, 0}, {16, 0}, {16, 0}, {16, 0}, {17, 0}, {18, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {19, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {16, 0}, {16, 0}, {20, 0}, {17, 0}, {20, 0}, {20, 0}, {16, 0}, {16, 0}, {0, 0}, {21, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {22, 0}, {0, 0}, {23, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {25, 0}, {16, 0}, {16, 0}, {16, 0}, {16, 0}, {16, 0}, {16, 0}, {16, 0}, {16, 0}, {16, 0}, {20, 0}, {20, 0}, {16, 0}, {16, 0}, {16, 0}, {16, 0}, {26, 0}, {26, 0}, {26, 0}, {26, 0}, {26, 0}, {26, 0}, {26, 0}, {26, 0}, {26, 0}, {26, 0}, {26, 0}, {26, 0}, {0, 0}, {0, 0}, {26, 0}, {26, 0}, {27, 0}, {28, 0}, {28, 0}, {29, 0}, {26, 0}, {26, 0}, {26, 0}, {30, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {26, 0}, {26, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {0, 0}, {0, 0}, {1, 1}, {0, 0}, {32, 0}, {33, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {32, 0}, {33, 0}, {34, 0}, {33, 0}, {33, 0}, {33, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {35, 0}, {36, 0}, {27, 0}, {37, 0}, {35, 0}, {38, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {26, 0}, {26, 0}, {26, 0}, {20, 0}, {26, 0}, {0, 0}, {39, 0}, {26, 0}, {26, 0}, {40, 0}, {26, 0}, {26, 0}, {26, 0}, {40, 0}, {26, 0}, {40, 0}, {26, 0}, {26, 0}, {40, 0}, {40, 0}, {26, 0}, {0, 0}, {41, 0}, {26, 0}, {26, 0}, {40, 0}, {26, 0}, {26, 0}, {26, 0}, {40, 0}, {26, 0}, {0, 0}, {26, 0}, {26, 0}, {26, 0}, {20, 0}, {26, 0}, {40, 0}, {39, 0}, {26, 0}, {26, 0}, {26, 0}, {20, 0}, {26, 0}, {26, 0}, {26, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {42, 9}, {42, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {43, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{44, 9}, {44, 9}, {44, 9}, {44, 9}, {44, 10}, {44, 11}, {44, 9}, {44, 9}, {44, 9}, {44, 9}, {44, 9}, {44, 9}, {44, 10}, {44, 11}, {44, 9}, {44, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {44, 12}, {44, 12}, {44, 12}, {44, 12}, {44, 13}, {44, 12}, {44, 12}, {44, 12}, {44, 12}, {44, 12}, {44, 12}, {44, 12}, {44, 13}, {44, 12}, {44, 12}, {44, 12}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {44, 11}, {44, 11}, {44, 11}, {44, 11}, {44, 14}, {44, 11}, {44, 11}, {44, 11}, {44, 11}, {44, 11}, {44, 11}, {44, 11}, {44, 14}, {44, 11}, {44, 11}, {44, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{45, 0}, {45, 0}, {45, 0}, {45, 0}, {46, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {46, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {46, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {46, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {46, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {46, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {46, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {46, 0}, {47, 0}, {45, 0}, {45, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {49, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {49, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {49, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {49, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {49, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {49, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {49, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {49, 0}, {48, 0}, {48, 0}, {48, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {50, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {50, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {50, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {50, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {50, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {50, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {50, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {50, 0}, {47, 0}, {47, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {51, 15}, {51, 16}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {51, 15}, {51, 16}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {51, 15}, {0, 0}, {0, 0}, {0, 0}, {51, 15}, {0, 0}, {51, 16}, {0, 0}, {0, 0}, {0, 0}, {51, 16}, {0, 0}, {51, 16}, {51, 16}, {0, 0}, {0, 0}, {51, 16}, {0, 0}, {0, 0}, {0, 0}, {51, 16}, {0, 0}, {51, 16}, {0, 0}, {0, 0}, {0, 0}, {51, 16}, {0, 0}, {51, 16}, {51, 16}, {0, 0}, {0, 0}, {51, 16}, {0, 0}, {0, 0}, {0, 0}, {51, 16}, {0, 0}, {51, 16}, {0, 0}, {0, 0}, {0, 0}, {51, 16}, {0, 0}, {51, 16}, {51, 16}, {0, 0}, {0, 0}, {0, 0}, {51, 15}, {0, 0}, {0, 0}, {0, 0}, {51, 16}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {45, 0}, {47, 0}, {45, 0}, {45, 0}},
  {{7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}, {7, 17}},
  {{7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}, {7, 18}},
  {{7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}, {7, 19}},
  {{8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}, {8, 20}},
  {{9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}, {9, 20}},
  {{48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}, {48, 0}},
  {{47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}, {47, 0}},
  {{52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}},
  {{52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}},
  {{54, 0}, {54, 0}, {54, 0}, {54, 0}, {26, 0}, {54, 0}, {54, 0}, {54, 0}, {54, 0}, {54, 0}, {54, 0}, {54, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {54, 0}, {54, 0}, {54, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {55, 0}, {55, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 10}, {56, 11}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 10}, {56, 11}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 10}, {56, 11}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 10}, {56, 11}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 10}, {56, 11}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 10}, {56, 11}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 10}, {56, 11}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 10}, {56, 11}, {56, 9}, {56, 9}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 13}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 13}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 13}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 13}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 13}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 13}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 13}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 12}, {56, 13}, {56, 12}, {56, 12}, {56, 12}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 14}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 14}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 14}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 14}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 14}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 14}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 14}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 11}, {56, 14}, {56, 11}, {56, 11}, {56, 11}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}, {56, 9}},
  {{30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 10}, {30, 11}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 10}, {30, 11}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 10}, {30, 11}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 10}, {30, 11}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 10}, {30, 11}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 10}, {30, 11}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 10}, {30, 11}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 10}, {30, 11}, {30, 9}, {30, 9}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 13}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 13}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 13}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 13}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 13}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 13}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 13}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 12}, {30, 13}, {30, 12}, {30, 12}, {30, 12}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 14}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 14}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 14}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 14}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 14}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 14}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 14}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 11}, {30, 14}, {30, 11}, {30, 11}, {30, 11}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}, {30, 9}},
  {{57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 10}, {57, 11}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 10}, {57, 11}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 10}, {57, 11}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 10}, {57, 11}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 10}, {57, 11}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 10}, {57, 11}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 10}, {57, 11}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 9}, {57, 10}, {57, 11}, {57, 9}, {57, 9}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 13}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 13}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 13}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 13}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 13}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 13}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 13}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 12}, {57, 13}, {57, 12}, {57, 12}, {57, 12}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 14}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 14}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 14}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 14}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 14}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 14}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 14}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 11}, {57, 14}, {57, 11}, {57, 11}, {57, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {58, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 22}, {56, 23}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 22}, {56, 23}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 22}, {56, 23}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 22}, {56, 23}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 22}, {56, 23}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 22}, {56, 23}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 22}, {56, 23}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 22}, {56, 23}, {56, 21}, {56, 21}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 25}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 25}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 25}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 25}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 25}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 25}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 25}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 24}, {56, 25}, {56, 24}, {56, 24}, {56, 24}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 26}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 26}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 26}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 26}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 26}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 26}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 26}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 23}, {56, 26}, {56, 23}, {56, 23}, {56, 23}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}, {56, 21}},
  {{59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {60, 0}, {59, 0}, {59, 0}},
  {{7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}, {7, 27}},
  {{7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}, {7, 28}},
  {{7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}, {7, 29}},
  {{8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}, {8, 30}},
  {{9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}, {9, 30}},
  {{61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}},
  {{60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}},
  {{62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 10}, {62, 11}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 10}, {62, 11}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 10}, {62, 11}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 10}, {62, 11}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 10}, {62, 11}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 10}, {62, 11}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 10}, {62, 11}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 10}, {62, 11}, {62, 9}, {62, 9}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 13}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 13}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 13}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 13}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 13}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 13}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 13}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 12}, {62, 13}, {62, 12}, {62, 12}, {62, 12}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 14}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 14}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 14}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 14}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 14}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 14}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 14}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 11}, {62, 14}, {62, 11}, {62, 11}, {62, 11}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}, {62, 9}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}},
  {{63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 22}, {63, 23}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 22}, {63, 23}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 22}, {63, 23}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 22}, {63, 23}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 22}, {63, 23}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 22}, {63, 23}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 22}, {63, 23}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 22}, {63, 23}, {63, 21}, {63, 21}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 25}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 25}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 25}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 25}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 25}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 25}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 25}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 24}, {63, 25}, {63, 24}, {63, 24}, {63, 24}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 26}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 26}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 26}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 26}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 26}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 26}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 26}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 23}, {63, 26}, {63, 23}, {63, 23}, {63, 23}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {30, 21}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}, {7, 31}},
  {{7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}, {7, 32}},
  {{7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}, {7, 33}},
  {{64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}, {64, 5}},
  {{59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}},
  {{43, 9}, {43, 9}, {43, 9}, {43, 9}, {43, 10}, {43, 11}, {43, 9}, {43, 9}, {43, 9}, {43, 9}, {43, 9}, {43, 9}, {43, 10}, {43, 11}, {43, 9}, {43, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 9}, {52, 10}, {52, 11}, {52, 9}, {52, 9}, {43, 9}, {43, 9}, {43, 9}, {43, 9}, {43, 10}, {43, 11}, {43, 9}, {43, 9}, {43, 9}, {43, 9}, {43, 9}, {43, 9}, {43, 10}, {43, 11}, {43, 9}, {43, 9}, {43, 9}, {43, 9}, {43, 9}, {43, 9}, {43, 10}, {43, 11}, {43, 9}, {43, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 13}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 13}, {43, 12}, {43, 12}, {43, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 12}, {52, 13}, {52, 12}, {52, 12}, {52, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 13}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 13}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 12}, {43, 13}, {43, 12}, {43, 12}, {43, 12}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 14}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 14}, {43, 11}, {43, 11}, {43, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 11}, {52, 14}, {52, 11}, {52, 11}, {52, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 14}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 14}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 11}, {43, 14}, {43, 11}, {43, 11}, {43, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {53, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {53, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {63, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 22}, {52, 23}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 22}, {52, 23}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 22}, {52, 23}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 22}, {52, 23}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 22}, {52, 23}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 22}, {52, 23}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 22}, {52, 23}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 22}, {52, 23}, {52, 21}, {52, 21}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 25}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 25}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 25}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 25}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 25}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 25}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 25}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 24}, {52, 25}, {52, 24}, {52, 24}, {52, 24}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 26}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 26}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 26}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 26}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 26}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 26}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 26}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 23}, {52, 26}, {52, 23}, {52, 23}, {52, 23}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}, {52, 21}},
  {{53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 10}, {53, 11}, {53, 9}, {53, 9}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 12}, {53, 13}, {53, 12}, {53, 12}, {53, 12}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 11}, {53, 14}, {53, 11}, {53, 11}, {53, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}, {63, 21}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {68, 9}, {68, 9}, {68, 9}, {68, 9}, {68, 10}, {68, 11}, {68, 9}, {68, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {68, 12}, {68, 12}, {68, 12}, {68, 12}, {68, 13}, {68, 12}, {68, 12}, {68, 12}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {68, 11}, {68, 11}, {68, 11}, {68, 11}, {68, 14}, {68, 11}, {68, 11}, {68, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}},
  {{63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}},
  {{63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 9}, {63, 10}, {63, 11}, {63, 9}, {63, 9}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 12}, {63, 13}, {63, 12}, {63, 12}, {63, 12}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 11}, {63, 14}, {63, 11}, {63, 11}, {63, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {69, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {31, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}, {71, 5}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {72, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {73, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {73, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {73, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {73, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {73, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {73, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {73, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {73, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {73, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{74, 0}, {0, 0}, {0, 0}, {0, 0}, {74, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{75, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{76, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {33, 0}, {0, 0}, {33, 0}, {0, 0}, {77, 0}, {0, 0}, {0, 0}, {0, 0}, {33, 0}, {0, 0}, {33, 0}, {0, 0}, {77, 0}, {0, 0}, {78, 0}, {0, 0}, {33, 0}, {0, 0}, {33, 0}, {0, 0}, {77, 0}, {0, 0}, {0, 0}, {0, 0}, {33, 0}, {0, 0}, {33, 0}, {0, 0}, {77, 0}, {0, 0}, {0, 0}, {0, 0}, {33, 0}, {0, 0}, {33, 0}, {0, 0}, {77, 0}, {0, 0}, {0, 0}, {0, 0}, {33, 0}, {0, 0}, {33, 0}, {0, 0}, {77, 0}, {79, 0}, {0, 0}, {0, 0}, {33, 0}, {0, 0}, {33, 0}, {0, 0}, {77, 0}, {0, 0}, {0, 0}, {0, 0}, {33, 0}, {0, 0}, {33, 0}, {0, 0}, {77, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {80, 0}, {0, 0}, {77, 0}, {81, 0}, {0, 0}, {32, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {81, 0}, {0, 0}, {32, 0}, {0, 0}, {33, 0}, {0, 0}, {33, 0}, {0, 0}, {33, 0}, {0, 0}, {33, 0}, {0, 0}, {82, 0}, {0, 0}, {19, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {0, 0}, {3, 0}, {0, 0}, {1, 1}, {0, 0}, {1, 1}, {0, 0}, {77, 0}, {0, 0}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {0, 0}, {83, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {84, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {85, 0}, {0, 0}, {85, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {86, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {87, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {88, 0}},
  {{7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}, {7, 34}},
  {{89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}, {89, 5}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {20, 0}, {20, 0}, {36, 0}, {36, 0}, {20, 0}, {20, 0}, {36, 0}, {36, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {90, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {20, 0}, {20, 0}, {20, 0}, {36, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {91, 0}, {0, 0}, {92, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {24, 0}, {93, 0}, {20, 0}, {0, 0}, {0, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {94, 0}, {95, 0}, {95, 0}, {96, 0}, {20, 0}, {20, 0}, {20, 0}, {0, 0}, {0, 0}, {97, 0}, {0, 0}, {0, 0}, {98, 0}, {98, 0}, {20, 0}, {20, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {33, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {0, 0}, {0, 0}, {94, 0}, {0, 0}, {35, 0}, {99, 0}, {94, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {93, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {36, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {0, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {93, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {75, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {100, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{101, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{74, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{54, 0}, {54, 0}, {54, 0}, {54, 0}, {54, 0}, {54, 0}, {54, 0}, {54, 0}, {54, 0}, {54, 0}, {54, 0}, {54, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {102, 0}, {0, 0}, {0, 0}, {0, 0}, {102, 0}, {102, 0}, {0, 0}, {102, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {54, 0}, {54, 0}, {54, 0}, {0, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {0, 0}, {0, 0}, {102, 0}, {102, 0}, {103, 0}, {102, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {0, 0}, {104, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {102, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {105, 0}, {105, 0}, {105, 0}, {105, 0}, {105, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}},
  {{106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 9}, {106, 10}, {106, 11}, {106, 9}, {106, 9}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 12}, {106, 13}, {106, 12}, {106, 12}, {106, 12}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 11}, {106, 14}, {106, 11}, {106, 11}, {106, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 10}, {107, 11}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 10}, {107, 11}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 10}, {107, 11}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 10}, {107, 11}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 10}, {107, 11}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 10}, {107, 11}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 10}, {107, 11}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 10}, {107, 11}, {107, 9}, {107, 9}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 13}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 13}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 13}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 13}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 13}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 13}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 13}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 12}, {107, 13}, {107, 12}, {107, 12}, {107, 12}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 14}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 14}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 14}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 14}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 14}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 14}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 14}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 11}, {107, 14}, {107, 11}, {107, 11}, {107, 11}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}, {107, 9}},
  {{108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 10}, {108, 11}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 10}, {108, 11}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 10}, {108, 11}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 10}, {108, 11}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 10}, {108, 11}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 10}, {108, 11}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 10}, {108, 11}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 10}, {108, 11}, {108, 9}, {108, 9}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 13}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 13}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 13}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 13}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 13}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 13}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 13}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 12}, {108, 13}, {108, 12}, {108, 12}, {108, 12}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 14}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 14}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 14}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 14}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 14}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 14}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 14}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 11}, {108, 14}, {108, 11}, {108, 11}, {108, 11}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}, {108, 9}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {109, 0}, {109, 0}, {109, 0}, {109, 0}, {109, 0}, {109, 0}, {109, 0}, {58, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {109, 0}, {109, 0}, {109, 0}, {109, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {109, 0}, {109, 0}, {109, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {109, 0}, {109, 0}, {109, 0}, {0, 0}, {110, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {111, 0}, {111, 0}, {111, 0}, {111, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {112, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 22}, {106, 23}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 22}, {106, 23}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 22}, {106, 23}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 22}, {106, 23}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 22}, {106, 23}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 22}, {106, 23}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 22}, {106, 23}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 22}, {106, 23}, {106, 21}, {106, 21}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 25}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 25}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 25}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 25}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 25}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 25}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 25}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 24}, {106, 25}, {106, 24}, {106, 24}, {106, 24}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 26}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 26}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 26}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 26}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 26}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 26}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 26}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 23}, {106, 26}, {106, 23}, {106, 23}, {106, 23}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}, {106, 21}},
  {{113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 22}, {113, 23}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 22}, {113, 23}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 22}, {113, 23}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 22}, {113, 23}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 22}, {113, 23}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 22}, {113, 23}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 22}, {113, 23}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 22}, {113, 23}, {113, 21}, {113, 21}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 25}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 25}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 25}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 25}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 25}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 25}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 25}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 24}, {113, 25}, {113, 24}, {113, 24}, {113, 24}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 26}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 26}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 26}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 26}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 26}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 26}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 26}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 23}, {113, 26}, {113, 23}, {113, 23}, {113, 23}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}, {113, 21}},
  {{107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 22}, {107, 23}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 22}, {107, 23}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 22}, {107, 23}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 22}, {107, 23}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 22}, {107, 23}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 22}, {107, 23}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 22}, {107, 23}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 22}, {107, 23}, {107, 21}, {107, 21}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 25}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 25}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 25}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 25}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 25}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 25}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 25}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 24}, {107, 25}, {107, 24}, {107, 24}, {107, 24}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 26}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 26}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 26}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 26}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 26}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 26}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 26}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 23}, {107, 26}, {107, 23}, {107, 23}, {107, 23}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}, {107, 21}},
  {{108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 22}, {108, 23}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 22}, {108, 23}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 22}, {108, 23}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 22}, {108, 23}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 22}, {108, 23}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 22}, {108, 23}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 22}, {108, 23}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 22}, {108, 23}, {108, 21}, {108, 21}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 25}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 25}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 25}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 25}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 25}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 25}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 25}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 24}, {108, 25}, {108, 24}, {108, 24}, {108, 24}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 26}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 26}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 26}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 26}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 26}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 26}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 26}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 23}, {108, 26}, {108, 23}, {108, 23}, {108, 23}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}, {108, 21}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}, {53, 9}},
  {{53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 22}, {53, 23}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 22}, {53, 23}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 22}, {53, 23}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 22}, {53, 23}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 22}, {53, 23}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 22}, {53, 23}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 22}, {53, 23}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 22}, {53, 23}, {53, 21}, {53, 21}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 25}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 25}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 25}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 25}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 25}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 25}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 25}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 24}, {53, 25}, {53, 24}, {53, 24}, {53, 24}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 26}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 26}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 26}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 26}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 26}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 26}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 26}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 23}, {53, 26}, {53, 23}, {53, 23}, {53, 23}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}},
  {{115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}, {53, 21}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {116, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {117, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {100, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {79, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {118, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {79, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {119, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {79, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {120, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {79, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {121, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {79, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}},
  {{77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {123, 0}, {77, 0}, {77, 0}},
  {{7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}, {7, 35}},
  {{7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}, {7, 36}},
  {{7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}, {7, 37}},
  {{8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}, {8, 38}},
  {{9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}, {9, 38}},
  {{124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}},
  {{123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}},
  {{77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}},
  {{0, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {127, 0}, {0, 0}, {128, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {129, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {130, 0}},
  {{77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{77, 0}, {77, 0}, {77, 0}, {77, 0}, {122, 0}, {123, 0}, {77, 0}, {77, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {124, 0}, {124, 0}, {124, 0}, {124, 0}, {125, 0}, {124, 0}, {124, 0}, {124, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {123, 0}, {123, 0}, {123, 0}, {123, 0}, {126, 0}, {123, 0}, {123, 0}, {123, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {77, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}},
  {{131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {133, 0}, {131, 0}, {131, 0}},
  {{7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}, {7, 39}},
  {{7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}, {7, 40}},
  {{7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}, {7, 41}},
  {{8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}, {8, 42}},
  {{9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}, {9, 42}},
  {{134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}},
  {{133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}},
  {{59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {137, 0}, {138, 0}, {139, 0}, {140, 0}, {141, 0}, {142, 0}, {143, 0}, {144, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}},
  {{10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 43}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {145, 0}, {146, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 44}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 44}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 44}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 44}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 44}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 44}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 44}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 45}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {148, 0}, {149, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 10}, {150, 11}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 10}, {150, 11}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 10}, {150, 11}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 10}, {150, 11}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 10}, {150, 11}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 10}, {150, 11}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 10}, {150, 11}, {150, 9}, {150, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 13}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 13}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 13}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 13}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 13}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 13}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 13}, {150, 12}, {150, 12}, {150, 12}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 14}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 14}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 14}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 14}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 14}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 14}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 14}, {150, 11}, {150, 11}, {150, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 10}, {150, 11}, {150, 9}, {150, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 10}, {150, 11}, {150, 9}, {150, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 13}, {150, 12}, {150, 12}, {150, 12}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {150, 12}, {150, 12}, {150, 12}, {150, 12}, {150, 13}, {150, 12}, {150, 12}, {150, 12}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 14}, {150, 11}, {150, 11}, {150, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {150, 11}, {150, 11}, {150, 11}, {150, 11}, {150, 14}, {150, 11}, {150, 11}, {150, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {150, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {148, 0}, {149, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {151, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {152, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 46}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 46}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 46}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 46}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 46}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 46}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 46}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 47}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {153, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 49}, {152, 50}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 49}, {152, 50}, {152, 48}, {152, 48}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {152, 51}, {152, 51}, {152, 51}, {152, 51}, {152, 52}, {152, 51}, {152, 51}, {152, 51}, {152, 51}, {152, 51}, {152, 51}, {152, 51}, {152, 52}, {152, 51}, {152, 51}, {152, 51}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {152, 50}, {152, 50}, {152, 50}, {152, 50}, {152, 53}, {152, 50}, {152, 50}, {152, 50}, {152, 50}, {152, 50}, {152, 50}, {152, 50}, {152, 53}, {152, 50}, {152, 50}, {152, 50}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {152, 48}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {154, 0}, {0, 0}, {153, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 49}, {155, 50}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 49}, {155, 50}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 49}, {155, 50}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 49}, {155, 50}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 49}, {155, 50}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 49}, {155, 50}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 49}, {155, 50}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 49}, {155, 50}, {155, 48}, {155, 48}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 52}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 52}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 52}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 52}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 52}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 52}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 52}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 51}, {155, 52}, {155, 51}, {155, 51}, {155, 51}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 53}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 53}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 53}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 53}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 53}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 53}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 53}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 50}, {155, 53}, {155, 50}, {155, 50}, {155, 50}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}, {155, 48}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {156, 0}, {157, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 54}, {147, 55}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 54}, {147, 55}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 54}, {147, 55}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 54}, {147, 55}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 54}, {147, 55}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 54}, {147, 55}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 54}, {147, 55}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 54}, {147, 56}, {0, 0}, {0, 0}, {0, 0}, {147, 57}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {158, 0}, {159, 0}, {0, 0}, {0, 0}, {0, 0}, {158, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 10}, {155, 11}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 10}, {155, 11}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 10}, {155, 11}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 10}, {155, 11}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 10}, {155, 11}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 10}, {155, 11}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 10}, {155, 11}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 10}, {155, 11}, {155, 9}, {155, 9}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 13}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 13}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 13}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 13}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 13}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 13}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 13}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 13}, {155, 12}, {155, 12}, {155, 12}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 14}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 14}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 14}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 14}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 14}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 14}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 14}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 14}, {155, 11}, {155, 11}, {155, 11}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 10}, {155, 11}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 10}, {155, 11}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 10}, {155, 11}, {155, 9}, {155, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 13}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 13}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 12}, {155, 13}, {155, 12}, {155, 12}, {155, 12}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 14}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 14}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 11}, {155, 14}, {155, 11}, {155, 11}, {155, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {155, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {160, 0}, {160, 0}, {160, 0}, {160, 0}, {160, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 10}, {161, 11}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 10}, {161, 11}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 10}, {161, 11}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 10}, {161, 11}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 10}, {161, 11}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 10}, {161, 11}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 10}, {161, 11}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 10}, {161, 11}, {161, 9}, {161, 9}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 13}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 13}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 13}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 13}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 13}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 13}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 13}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 12}, {161, 13}, {161, 12}, {161, 12}, {161, 12}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 14}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 14}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 14}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 14}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 14}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 14}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 14}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 11}, {161, 14}, {161, 11}, {161, 11}, {161, 11}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}, {161, 9}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {162, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {160, 0}, {160, 0}, {160, 0}, {160, 0}, {160, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 10}, {163, 11}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 10}, {163, 11}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 10}, {163, 11}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 10}, {163, 11}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 10}, {163, 11}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 10}, {163, 11}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 10}, {163, 11}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 10}, {163, 11}, {163, 9}, {163, 9}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 13}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 13}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 13}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 13}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 13}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 13}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 13}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 12}, {163, 13}, {163, 12}, {163, 12}, {163, 12}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 14}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 14}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 14}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 14}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 14}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 14}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 14}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 11}, {163, 14}, {163, 11}, {163, 11}, {163, 11}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}, {163, 9}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {162, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 58}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 58}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 58}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 58}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 58}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 58}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 58}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {147, 59}, {0, 0}, {0, 0}, {0, 0}, {147, 60}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {164, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {165, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 22}, {166, 23}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 22}, {166, 23}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 22}, {166, 23}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 22}, {166, 23}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 22}, {166, 23}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 22}, {166, 23}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 22}, {166, 23}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 22}, {166, 23}, {166, 21}, {166, 21}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 25}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 25}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 25}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 25}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 25}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 25}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 25}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 24}, {166, 25}, {166, 24}, {166, 24}, {166, 24}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 26}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 26}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 26}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 26}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 26}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 26}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 26}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 23}, {166, 26}, {166, 23}, {166, 23}, {166, 23}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}, {166, 21}},
  {{161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 22}, {161, 23}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 22}, {161, 23}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 22}, {161, 23}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 22}, {161, 23}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 22}, {161, 23}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 22}, {161, 23}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 22}, {161, 23}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 22}, {161, 23}, {161, 21}, {161, 21}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 25}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 25}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 25}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 25}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 25}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 25}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 25}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 24}, {161, 25}, {161, 24}, {161, 24}, {161, 24}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 26}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 26}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 26}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 26}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 26}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 26}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 26}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 23}, {161, 26}, {161, 23}, {161, 23}, {161, 23}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}, {161, 21}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {167, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {164, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {165, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 22}, {163, 23}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 22}, {163, 23}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 22}, {163, 23}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 22}, {163, 23}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 22}, {163, 23}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 22}, {163, 23}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 22}, {163, 23}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 22}, {163, 23}, {163, 21}, {163, 21}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 25}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 25}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 25}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 25}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 25}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 25}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 25}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 24}, {163, 25}, {163, 24}, {163, 24}, {163, 24}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 26}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 26}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 26}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 26}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 26}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 26}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 26}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 23}, {163, 26}, {163, 23}, {163, 23}, {163, 23}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}, {163, 21}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {167, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}},
  {{168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {0, 0}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}},
  {{168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {169, 9}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}},
  {{168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}},
  {{168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 10}, {168, 11}, {168, 9}, {168, 9}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 12}, {168, 13}, {168, 12}, {168, 12}, {168, 12}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 11}, {168, 14}, {168, 11}, {168, 11}, {168, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {168, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}, {7, 61}},
  {{7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}, {7, 62}},
  {{7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}, {7, 63}},
  {{64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}, {64, 64}},
  {{82, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {170, 0}, {82, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {128, 0}, {171, 0}, {0, 0}, {128, 0}, {0, 0}, {0, 0}, {82, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {129, 0}, {129, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {130, 0}, {130, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {82, 0}, {82, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {38, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {172, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {20, 0}, {20, 0}, {98, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {20, 0}, {173, 0}, {20, 0}, {20, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {174, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {20, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {20, 0}, {20, 0}, {20, 0}, {0, 0}, {20, 0}, {20, 0}, {20, 0}, {20, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {94, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {175, 0}, {97, 0}, {0, 0}, {0, 0}, {98, 0}, {98, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {94, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {16, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {93, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {20, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {176, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 10}, {114, 11}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 10}, {114, 11}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 10}, {114, 11}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 10}, {114, 11}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 10}, {114, 11}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 10}, {114, 11}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 10}, {114, 11}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 9}, {114, 10}, {114, 11}, {114, 9}, {114, 9}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 13}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 13}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 13}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 13}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 13}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 13}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 13}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 12}, {114, 13}, {114, 12}, {114, 12}, {114, 12}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 14}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 14}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 14}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 14}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 14}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 14}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 14}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 11}, {114, 14}, {114, 11}, {114, 11}, {114, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {104, 0}, {104, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}, {114, 65}},
  {{10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}, {10, 66}},
  {{177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}, {177, 5}},
  {{115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 9}, {115, 10}, {115, 11}, {115, 9}, {115, 9}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 12}, {115, 13}, {115, 12}, {115, 12}, {115, 12}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 11}, {115, 14}, {115, 11}, {115, 11}, {115, 11}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {178, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {16, 0}, {16, 0}, {98, 0}, {0, 0}, {0, 0}, {0, 0}, {98, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {16, 0}, {173, 0}, {16, 0}, {16, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {16, 0}, {16, 0}, {16, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {16, 0}, {16, 0}, {20, 0}, {20, 0}, {16, 0}, {16, 0}, {16, 0}, {16, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {20, 0}, {94, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {20, 0}, {20, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {179, 0}, {0, 0}, {0, 0}, {0, 0}, {180, 0}, {181, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {35, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {93, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {20, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 10}, {182, 11}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 10}, {182, 11}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 10}, {182, 11}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 10}, {182, 11}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 10}, {182, 11}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 10}, {182, 11}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 10}, {182, 11}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 10}, {182, 11}, {182, 9}, {182, 9}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 13}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 13}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 13}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 13}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 13}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 13}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 13}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 12}, {182, 13}, {182, 12}, {182, 12}, {182, 12}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 14}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 14}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 14}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 14}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 14}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 14}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 14}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 11}, {182, 14}, {182, 11}, {182, 11}, {182, 11}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}, {182, 9}},
  {{183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 10}, {183, 11}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 10}, {183, 11}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 10}, {183, 11}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 10}, {183, 11}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 10}, {183, 11}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 10}, {183, 11}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 10}, {183, 11}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 10}, {183, 11}, {183, 9}, {183, 9}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 13}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 13}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 13}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 13}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 13}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 13}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 13}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 12}, {183, 13}, {183, 12}, {183, 12}, {183, 12}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 14}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 14}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 14}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 14}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 14}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 14}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 14}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 11}, {183, 14}, {183, 11}, {183, 11}, {183, 11}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}, {183, 9}},
  {{184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 10}, {184, 11}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 10}, {184, 11}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 10}, {184, 11}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 10}, {184, 11}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 10}, {184, 11}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 10}, {184, 11}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 10}, {184, 11}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 10}, {184, 11}, {184, 9}, {184, 9}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 13}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 13}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 13}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 13}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 13}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 13}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 13}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 12}, {184, 13}, {184, 12}, {184, 12}, {184, 12}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 14}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 14}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 14}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 14}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 14}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 14}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 14}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 11}, {184, 14}, {184, 11}, {184, 11}, {184, 11}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}, {184, 9}},
  {{59, 0}, {59, 0}, {59, 0}, {59, 0}, {65, 0}, {60, 0}, {59, 0}, {59, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {61, 0}, {61, 0}, {61, 0}, {61, 0}, {66, 0}, {61, 0}, {61, 0}, {61, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {60, 0}, {60, 0}, {60, 0}, {60, 0}, {67, 0}, {60, 0}, {60, 0}, {60, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}},
  {{131, 0}, {131, 0}, {131, 0}, {131, 0}, {132, 0}, {133, 0}, {131, 0}, {131, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {134, 0}, {134, 0}, {134, 0}, {134, 0}, {135, 0}, {134, 0}, {134, 0}, {134, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {133, 0}, {133, 0}, {133, 0}, {133, 0}, {136, 0}, {133, 0}, {133, 0}, {133, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {185, 67}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {185, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 68}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {185, 67}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {185, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 69}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {185, 67}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {185, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 70}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {185, 67}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {185, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 71}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {185, 67}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {185, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 72}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {185, 67}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {185, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 73}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {185, 67}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {185, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 74}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}, {10, 5}},
  {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {2, 0}, {3, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {4, 0}, {4, 0}, {4, 0}, {4, 0}, {5, 0}, {4, 0}, {4, 0}, {4, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {6, 0}, {3, 0}, {3, 0}, {3, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {185, 67}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {185, 9}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
  {{33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {186, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {188, 0}, {189, 0}, {0, 0}, {131, 0}, {190, 0}, {59, 0}, {32, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {32, 0}, {190, 0}, {0, 0}, {191, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {0, 0}, {82, 0}, {0, 0}, {192, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {168, 9}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {59, 0}, {131, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {83, 0}, {83, 0}, {0, 0}, {0, 0}, {193, 0}, {0, 0}, {194, 0}, {195, 0}, {0, 0}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {85, 0}, {85, 0}, {85, 0}, {85, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {196, 0}, {197, 0}, {198, 0}, {199, 0}, {200, 0}, {201, 0}, {202, 0}, {203, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {204, 0}, {31, 0}, {0, 0}, {70, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {205, 0}, {0, 0}, {206, 0}, {207, 0}, {1, 1}, {1, 1}, {208, 0}, {209, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {210, 0}, {88, 0}},
  {{33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {186, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {188, 0}, {189, 0}, {0, 0}, {131, 0}, {190, 0}, {59, 0}, {32, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {32, 0}, {190, 0}, {0, 0}, {191, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {0, 0}, {82, 0}, {0, 0}, {192, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {168, 9}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {59, 0}, {131, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {83, 0}, {83, 0}, {0, 0}, {0, 0}, {193, 0}, {0, 0}, {194, 0}, {195, 0}, {0, 0}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {85, 0}, {85, 0}, {85, 0}, {85, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {196, 0}, {197, 0}, {198, 0}, {199, 0}, {200, 0}, {201, 0}, {202, 0}, {203, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {204, 0}, {31, 0}, {0, 0}, {70, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {205, 0}, {0, 0}, {206, 0}, {207, 0}, {1, 1}, {1, 1}, {208, 0}, {209, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {210, 0}, {211, 0}},
  {{33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {186, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {188, 0}, {189, 0}, {0, 0}, {131, 0}, {190, 0}, {59, 0}, {32, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {32, 0}, {190, 0}, {0, 0}, {191, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {0, 0}, {82, 0}, {0, 0}, {192, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {168, 9}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {59, 0}, {131, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {83, 0}, {83, 0}, {0, 0}, {0, 0}, {193, 0}, {0, 0}, {194, 0}, {195, 0}, {0, 0}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {85, 0}, {85, 0}, {85, 0}, {85, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {196, 0}, {197, 0}, {198, 0}, {199, 0}, {200, 0}, {201, 0}, {202, 0}, {203, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {204, 0}, {31, 0}, {0, 0}, {70, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {205, 0}, {0, 0}, {206, 0}, {207, 0}, {1, 1}, {1, 1}, {208, 0}, {209, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {210, 0}, {212, 0}},
  {{33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {186, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {188, 0}, {189, 0}, {0, 0}, {131, 0}, {190, 0}, {59, 0}, {32, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {32, 0}, {190, 0}, {0, 0}, {191, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {0, 0}, {82, 0}, {0, 0}, {192, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {168, 9}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {59, 0}, {131, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {83, 0}, {83, 0}, {0, 0}, {0, 0}, {193, 0}, {0, 0}, {194, 0}, {195, 0}, {0, 0}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {85, 0}, {85, 0}, {85, 0}, {85, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {196, 0}, {197, 0}, {198, 0}, {199, 0}, {200, 0}, {201, 0}, {202, 0}, {203, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {204, 0}, {31, 0}, {0, 0}, {70, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {205, 0}, {0, 0}, {206, 0}, {207, 0}, {1, 1}, {1, 1}, {208, 0}, {209, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {210, 0}, {213, 0}},
  {{33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {186, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {188, 0}, {189, 0}, {0, 0}, {131, 0}, {190, 0}, {59, 0}, {32, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {32, 0}, {190, 0}, {0, 0}, {191, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {0, 0}, {82, 0}, {0, 0}, {192, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {168, 9}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {59, 0}, {131, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {83, 0}, {83, 0}, {0, 0}, {0, 0}, {193, 0}, {0, 0}, {194, 0}, {195, 0}, {0, 0}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {85, 0}, {85, 0}, {85, 0}, {85, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {196, 0}, {197, 0}, {198, 0}, {199, 0}, {200, 0}, {201, 0}, {202, 0}, {203, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {204, 0}, {31, 0}, {0, 0}, {70, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {205, 0}, {0, 0}, {206, 0}, {207, 0}, {1, 1}, {1, 1}, {208, 0}, {209, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {210, 0}, {214, 0}},
  {{33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {186, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {188, 0}, {189, 0}, {0, 0}, {131, 0}, {190, 0}, {59, 0}, {32, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {32, 0}, {190, 0}, {0, 0}, {191, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {0, 0}, {82, 0}, {0, 0}, {192, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {168, 9}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {59, 0}, {131, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {83, 0}, {83, 0}, {0, 0}, {0, 0}, {193, 0}, {0, 0}, {194, 0}, {195, 0}, {0, 0}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {85, 0}, {85, 0}, {85, 0}, {85, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {196, 0}, {197, 0}, {198, 0}, {199, 0}, {200, 0}, {201, 0}, {202, 0}, {203, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {204, 0}, {31, 0}, {0, 0}, {70, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {205, 0}, {0, 0}, {206, 0}, {207, 0}, {1, 1}, {1, 1}, {208, 0}, {209, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {210, 0}, {215, 0}},
  {{33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {186, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {188, 0}, {189, 0}, {0, 0}, {131, 0}, {190, 0}, {59, 0}, {32, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {32, 0}, {190, 0}, {0, 0}, {191, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {0, 0}, {82, 0}, {0, 0}, {192, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {168, 9}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {59, 0}, {131, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {83, 0}, {83, 0}, {0, 0}, {0, 0}, {193, 0}, {0, 0}, {194, 0}, {195, 0}, {0, 0}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {85, 0}, {85, 0}, {85, 0}, {85, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {196, 0}, {197, 0}, {198, 0}, {199, 0}, {200, 0}, {201, 0}, {202, 0}, {203, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {204, 0}, {31, 0}, {0, 0}, {70, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {205, 0}, {0, 0}, {206, 0}, {207, 0}, {1, 1}, {1, 1}, {208, 0}, {209, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {210, 0}, {216, 0}},
  {{33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {186, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {188, 0}, {189, 0}, {0, 0}, {131, 0}, {190, 0}, {59, 0}, {32, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {32, 0}, {190, 0}, {0, 0}, {191, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {0, 0}, {82, 0}, {0, 0}, {192, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {168, 9}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {59, 0}, {131, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {83, 0}, {83, 0}, {0, 0}, {0, 0}, {193, 0}, {0, 0}, {194, 0}, {195, 0}, {0, 0}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {85, 0}, {85, 0}, {85, 0}, {85, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {196, 0}, {197, 0}, {198, 0}, {199, 0}, {200, 0}, {201, 0}, {202, 0}, {203, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {204, 0}, {31, 0}, {0, 0}, {70, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {205, 0}, {0, 0}, {206, 0}, {207, 0}, {1, 1}, {1, 1}, {208, 0}, {209, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {210, 0}, {217, 0}},
  {{33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {186, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {0, 0}, {0, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {59, 0}, {131, 0}, {187, 0}, {0, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {188, 0}, {189, 0}, {0, 0}, {131, 0}, {190, 0}, {59, 0}, {32, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {70, 0}, {32, 0}, {190, 0}, {0, 0}, {191, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {33, 0}, {0, 0}, {82, 0}, {0, 0}, {192, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {0, 0}, {168, 9}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {3, 0}, {3, 0}, {3, 0}, {3, 0}, {1, 1}, {1, 1}, {1, 1}, {1, 1}, {59, 0}, {131, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {59, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {131, 0}, {83, 0}, {83, 0}, {0, 0}, {0, 0}, {193, 0}, {0, 0}, {194, 0}, {195, 0}, {0, 0}, {1, 1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {85, 0}, {85, 0}, {85, 0}, {85, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {196, 0}, {197, 0}, {198, 0}, {199, 0}, {200, 0}, {201, 0}, {202, 0}, {203, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {204, 0}, {31, 0}, {0, 0}, {70, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {205, 0}, {0, 0}, {206, 0}, {207, 0}, {1, 1}, {1, 1}, {208, 0}, {209, 0}, {1, 1}, {1, 1}, {0, 0}, {0, 0}, {1, 1}, {1, 1}, {210, 0}, {218, 0}}
};

Bool ValidateChunkIA32(const uint8_t codeblock[],
                       size_t size,
                       uint32_t options,
                       const NaClCPUFeaturesX86 *cpu_features,
                       ValidationCallbackFunc user_callback,
                       void *callback_data) {
  bitmap_word valid_targets_small;
  bitmap_word jump_dests_small;
  bitmap_word *valid_targets;
  bitmap_word *jump_dests;
  const uint8_t *current_position;
  const uint8_t *end_position;
  int result = TRUE;

  CHECK(sizeof valid_targets_small == sizeof jump_dests_small);
  CHECK(size % kBundleSize == 0);

  /* For a very small sequences (one bundle) malloc is too expensive.  */
  if (size <= (sizeof valid_targets_small * 8)) {
    valid_targets_small = 0;
    valid_targets = &valid_targets_small;
    jump_dests_small = 0;
    jump_dests = &jump_dests_small;
  } else {
    valid_targets = BitmapAllocate(size);
    jump_dests = BitmapAllocate(size);
    if (!valid_targets || !jump_dests) {
      free(jump_dests);
      free(valid_targets);
      errno = ENOMEM;
      return FALSE;
    }
  }

  /*
   * This option is usually used in tests: we will process the whole chunk
   * in one pass. Usually each bundle is processed separately which means
   * instructions (and "superinstructions") can not cross borders of the bundle.
   */
  if (options & PROCESS_CHUNK_AS_A_CONTIGUOUS_STREAM)
    end_position = codeblock + size;
  else
    end_position = codeblock + kBundleSize;

  /*
   * Main loop.  Here we process the data array bundle-after-bundle.
   * Ragel-produced DFA does all the checks with one exception: direct jumps.
   * It collects the two arrays: valid_targets and jump_dests which are used
   * to test direct jumps later.
   */
  for (current_position = codeblock;
       current_position < codeblock + size;
       current_position = end_position,
       end_position = current_position + kBundleSize) {
    /* Start of the instruction being processed.  */
    const uint8_t *instruction_begin = current_position;
    /* Only used locally in the end_of_instruction_cleanup action.  */
    const uint8_t *instruction_end;
    uint32_t instruction_info_collected = 0;
    int current_state;

    /*
     * The "write init" statement causes Ragel to emit initialization code.
     * This should be executed once before the ragel machine is started.
     */
current_state = 214;
    /*
     * The "write exec" statement causes Ragel to emit the ragel machine's
     * execution code.
     */
_again:
if (current_position == end_position) {
  if (_dfa_accepting[current_state]) goto _done;
  
    result &= user_callback(instruction_begin, current_position,
                            UNRECOGNIZED_INSTRUCTION, callback_data);
    /*
     * Process the next bundle: "continue" here is for the "for" cycle in
     * the ValidateChunkIA32 function.
     *
     * It does not affect the case which we really care about (when code
     * is validatable), but makes it possible to detect more errors in one
     * run in tools like ncval.
     */
    continue;
  }
switch (_dfa_transitions[current_state][*current_position][0]) {
  case 0:

    result &= user_callback(instruction_begin, current_position,
                            UNRECOGNIZED_INSTRUCTION, callback_data);
    /*
     * Process the next bundle: "continue" here is for the "for" cycle in
     * the ValidateChunkIA32 function.
     *
     * It does not affect the case which we really care about (when code
     * is validatable), but makes it possible to detect more errors in one
     * run in tools like ncval.
     */
    continue;
    break;
  case 1:

    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
    break;
  case 2:
current_state = 2; current_position++; goto _again;
  break;
  case 3:
current_state = 3; current_position++; goto _again;
  break;
  case 4:
current_state = 7; current_position++; goto _again;
  break;
  case 5:
current_state = 8; current_position++; goto _again;
  break;
  case 6:
current_state = 9; current_position++; goto _again;
  break;
  case 7:
  break;
  case 8:

    SET_DISPLACEMENT_FORMAT(DISP32);
    SET_DISPLACEMENT_POINTER(current_position - 3);
    break;
  case 9:

    SET_DISPLACEMENT_FORMAT(DISP8);
    SET_DISPLACEMENT_POINTER(current_position);
    break;
  case 10:

    SET_IMMEDIATE_FORMAT(IMM8);
    SET_IMMEDIATE_POINTER(current_position);
    break;
  case 11:

    SET_IMMEDIATE_FORMAT(IMM32);
    SET_IMMEDIATE_POINTER(current_position - 3);
    break;
  case 12:
current_state = 16; current_position++; goto _again;
  break;
  case 13:
current_state = 17; current_position++; goto _again;
  break;
  case 14:
 SET_CPU_FEATURE(CPUFeature_3DNOW);       break;
  case 15:
current_state = 18; current_position++; goto _again;
  break;
  case 16:
current_state = 28; current_position++; goto _again;
  break;
  case 17:
current_state = 29; current_position++; goto _again;
  break;
  case 18:
current_state = 30; current_position++; goto _again;
  break;
  case 19:
current_state = 31; current_position++; goto _again;
  break;
  case 20:
current_state = 32; current_position++; goto _again;
  break;
  case 21:
 SET_CPU_FEATURE(CPUFeature_TSC);         break;
  case 22:
current_state = 33; current_position++; goto _again;
  break;
  case 23:
current_state = 37; current_position++; goto _again;
  break;
  case 24:
current_state = 47; current_position++; goto _again;
  break;
  case 25:
current_state = 48; current_position++; goto _again;
  break;
  case 26:
current_state = 35; current_position++; goto _again;
  break;
  case 27:
current_state = 49; current_position++; goto _again;
  break;
  case 28:
current_state = 50; current_position++; goto _again;
  break;
  case 29:
current_state = 51; current_position++; goto _again;
  break;
  case 30:
 SET_CPU_FEATURE(CPUFeature_MMX);         break;
  case 31:
current_state = 52; current_position++; goto _again;
  break;
  case 32:
current_state = 56; current_position++; goto _again;
  break;
  case 33:
current_state = 1; current_position++; goto _again;
  break;
  case 34:
current_state = 57; current_position++; goto _again;
  break;
  case 35:
current_state = 58; current_position++; goto _again;
  break;
  case 36:
current_state = 59; current_position++; goto _again;
  break;
  case 37:
current_state = 60; current_position++; goto _again;
  break;
  case 38:
current_state = 61; current_position++; goto _again;
  break;
  case 39:
current_state = 62; current_position++; goto _again;
  break;
  case 40:
current_state = 63; current_position++; goto _again;
  break;
  case 41:
current_state = 64; current_position++; goto _again;
  break;
  case 42:
 SET_CPU_FEATURE(CPUFeature_MON);         break;
  case 43:
 SET_CPU_FEATURE(CPUFeature_FXSR);        break;
  case 44:
 SET_CPU_FEATURE(CPUFeature_3DPRFTCH);    break;
  case 45:
current_state = 19; current_position++; goto _again;
  break;
  case 46:
current_state = 20; current_position++; goto _again;
  break;
  case 47:
current_state = 21; current_position++; goto _again;
  break;
  case 48:
current_state = 25; current_position++; goto _again;
  break;
  case 49:
current_state = 26; current_position++; goto _again;
  break;
  case 50:
current_state = 27; current_position++; goto _again;
  break;
  case 51:

    instruction_info_collected |= LAST_BYTE_IS_NOT_IMMEDIATE;
    break;
  case 52:
 SET_CPU_FEATURE(CPUFeature_SSE);         break;
  case 53:
 SET_CPU_FEATURE(CPUFeature_SSE2);        break;
  case 54:
current_state = 34; current_position++; goto _again;
  break;
  case 55:
current_state = 36; current_position++; goto _again;
  break;
  case 56:
 SET_CPU_FEATURE(CPUFeature_SSSE3);       break;
  case 57:
 SET_CPU_FEATURE(CPUFeature_MOVBE);       break;
  case 58:
current_state = 38; current_position++; goto _again;
  break;
  case 59:
current_state = 10; current_position++; goto _again;
  break;
  case 60:
current_state = 40; current_position++; goto _again;
  break;
  case 61:
current_state = 44; current_position++; goto _again;
  break;
  case 62:
 SET_CPU_FEATURE(CPUFeature_CMOV);        break;
  case 63:
 SET_CPU_FEATURE(CPUFeature_EMMXSSE);     break;
  case 64:

    Rel32Operand(current_position + 1, codeblock, jump_dests, size,
                 &instruction_info_collected);
    break;
  case 65:
current_state = 39; current_position++; goto _again;
  break;
  case 66:
current_state = 45; current_position++; goto _again;
  break;
  case 67:
current_state = 46; current_position++; goto _again;
  break;
  case 68:
 SET_CPU_FEATURE(CPUFeature_CX8);         break;
  case 69:
current_state = 66; current_position++; goto _again;
  break;
  case 70:
current_state = 67; current_position++; goto _again;
  break;
  case 71:

    Rel8Operand(current_position + 1, codeblock, jump_dests, size,
                &instruction_info_collected);
    break;
  case 72:
current_state = 69; current_position++; goto _again;
  break;
  case 73:
current_state = 70; current_position++; goto _again;
  break;
  case 74:
current_state = 71; current_position++; goto _again;
  break;
  case 75:
current_state = 72; current_position++; goto _again;
  break;
  case 76:
current_state = 73; current_position++; goto _again;
  break;
  case 77:
current_state = 75; current_position++; goto _again;
  break;
  case 78:
current_state = 77; current_position++; goto _again;
  break;
  case 79:
current_state = 98; current_position++; goto _again;
  break;
  case 80:
current_state = 101; current_position++; goto _again;
  break;
  case 81:
current_state = 106; current_position++; goto _again;
  break;
  case 82:
current_state = 115; current_position++; goto _again;
  break;
  case 83:
current_state = 116; current_position++; goto _again;
  break;
  case 84:
current_state = 117; current_position++; goto _again;
  break;
  case 85:
current_state = 118; current_position++; goto _again;
  break;
  case 86:
current_state = 119; current_position++; goto _again;
  break;
  case 87:
current_state = 124; current_position++; goto _again;
  break;
  case 88:
current_state = 125; current_position++; goto _again;
  break;
  case 89:

    SET_IMMEDIATE_FORMAT(IMM16);
    SET_IMMEDIATE_POINTER(current_position - 1);
    break;
  case 90:
current_state = 78; current_position++; goto _again;
  break;
  case 91:
current_state = 81; current_position++; goto _again;
  break;
  case 92:
current_state = 86; current_position++; goto _again;
  break;
  case 93:
current_state = 91; current_position++; goto _again;
  break;
  case 94:
current_state = 92; current_position++; goto _again;
  break;
  case 95:
current_state = 93; current_position++; goto _again;
  break;
  case 96:
current_state = 94; current_position++; goto _again;
  break;
  case 97:
current_state = 95; current_position++; goto _again;
  break;
  case 98:
current_state = 96; current_position++; goto _again;
  break;
  case 99:
current_state = 97; current_position++; goto _again;
  break;
  case 100:
current_state = 79; current_position++; goto _again;
  break;
  case 101:
current_state = 80; current_position++; goto _again;
  break;
  case 102:
current_state = 82; current_position++; goto _again;
  break;
  case 103:
current_state = 83; current_position++; goto _again;
  break;
  case 104:
current_state = 84; current_position++; goto _again;
  break;
  case 105:
current_state = 85; current_position++; goto _again;
  break;
  case 106:
 SET_CPU_FEATURE(CPUFeature_SSE41);       break;
  case 107:
 SET_CPU_FEATURE(CPUFeature_SSE42);       break;
  case 108:
 SET_CPU_FEATURE(CPUFeature_AES);         break;
  case 109:
current_state = 87; current_position++; goto _again;
  break;
  case 110:
current_state = 88; current_position++; goto _again;
  break;
  case 111:
current_state = 89; current_position++; goto _again;
  break;
  case 112:
current_state = 90; current_position++; goto _again;
  break;
  case 113:
 SET_CPU_FEATURE(CPUFeature_CLMUL);       break;
  case 114:
 SET_CPU_FEATURE(CPUFeature_SSE4A);       break;
  case 115:
 SET_CPU_FEATURE(CPUFeature_SSE3);        break;
  case 116:
current_state = 99; current_position++; goto _again;
  break;
  case 117:
current_state = 100; current_position++; goto _again;
  break;
  case 118:
current_state = 102; current_position++; goto _again;
  break;
  case 119:
current_state = 103; current_position++; goto _again;
  break;
  case 120:
current_state = 104; current_position++; goto _again;
  break;
  case 121:
current_state = 105; current_position++; goto _again;
  break;
  case 122:
current_state = 107; current_position++; goto _again;
  break;
  case 123:
current_state = 108; current_position++; goto _again;
  break;
  case 124:
current_state = 112; current_position++; goto _again;
  break;
  case 125:
current_state = 113; current_position++; goto _again;
  break;
  case 126:
current_state = 114; current_position++; goto _again;
  break;
  case 127:
current_state = 120; current_position++; goto _again;
  break;
  case 128:
current_state = 121; current_position++; goto _again;
  break;
  case 129:
current_state = 122; current_position++; goto _again;
  break;
  case 130:
current_state = 123; current_position++; goto _again;
  break;
  case 131:
current_state = 11; current_position++; goto _again;
  break;
  case 132:
current_state = 127; current_position++; goto _again;
  break;
  case 133:
current_state = 128; current_position++; goto _again;
  break;
  case 134:
current_state = 132; current_position++; goto _again;
  break;
  case 135:
current_state = 133; current_position++; goto _again;
  break;
  case 136:
current_state = 134; current_position++; goto _again;
  break;
  case 137:
current_state = 136; current_position++; goto _again;
  break;
  case 138:
current_state = 200; current_position++; goto _again;
  break;
  case 139:
current_state = 202; current_position++; goto _again;
  break;
  case 140:
current_state = 204; current_position++; goto _again;
  break;
  case 141:
current_state = 206; current_position++; goto _again;
  break;
  case 142:
current_state = 208; current_position++; goto _again;
  break;
  case 143:
current_state = 210; current_position++; goto _again;
  break;
  case 144:
current_state = 212; current_position++; goto _again;
  break;
  case 145:
current_state = 138; current_position++; goto _again;
  break;
  case 146:
current_state = 144; current_position++; goto _again;
  break;
  case 147:

    SET_VEX_PREFIX3(*current_position);
    break;
  case 148:
current_state = 140; current_position++; goto _again;
  break;
  case 149:
current_state = 141; current_position++; goto _again;
  break;
  case 150:
 SET_CPU_FEATURE(CPUFeature_TBM);         break;
  case 151:
current_state = 143; current_position++; goto _again;
  break;
  case 152:
 SET_CPU_FEATURE(CPUFeature_LWP);         break;
  case 153:
current_state = 146; current_position++; goto _again;
  break;
  case 154:
current_state = 148; current_position++; goto _again;
  break;
  case 155:
 SET_CPU_FEATURE(CPUFeature_BMI1);        break;
  case 156:
current_state = 150; current_position++; goto _again;
  break;
  case 157:
current_state = 159; current_position++; goto _again;
  break;
  case 158:
current_state = 152; current_position++; goto _again;
  break;
  case 159:
current_state = 153; current_position++; goto _again;
  break;
  case 160:
current_state = 155; current_position++; goto _again;
  break;
  case 161:
 SET_CPU_FEATURE(CPUFeature_AESAVX);      break;
  case 162:
current_state = 157; current_position++; goto _again;
  break;
  case 163:
 SET_CPU_FEATURE(CPUFeature_F16C);        break;
  case 164:
current_state = 161; current_position++; goto _again;
  break;
  case 165:
current_state = 162; current_position++; goto _again;
  break;
  case 166:
 SET_CPU_FEATURE(CPUFeature_CLMULAVX);    break;
  case 167:
current_state = 164; current_position++; goto _again;
  break;
  case 168:
 SET_CPU_FEATURE(CPUFeature_x87);         break;
  case 169:
 SET_CPU_FEATURE(CPUFeature_CMOVx87);     break;
  case 170:
current_state = 181; current_position++; goto _again;
  break;
  case 171:
current_state = 182; current_position++; goto _again;
  break;
  case 172:
current_state = 184; current_position++; goto _again;
  break;
  case 173:
current_state = 185; current_position++; goto _again;
  break;
  case 174:
current_state = 186; current_position++; goto _again;
  break;
  case 175:
current_state = 187; current_position++; goto _again;
  break;
  case 176:
current_state = 190; current_position++; goto _again;
  break;
  case 177:

    SET_SECOND_IMMEDIATE_FORMAT(IMM8);
    SET_SECOND_IMMEDIATE_POINTER(current_position);
    break;
  case 178:
current_state = 192; current_position++; goto _again;
  break;
  case 179:
current_state = 193; current_position++; goto _again;
  break;
  case 180:
current_state = 194; current_position++; goto _again;
  break;
  case 181:
current_state = 195; current_position++; goto _again;
  break;
  case 182:
 SET_CPU_FEATURE(CPUFeature_POPCNT);      break;
  case 183:
 SET_CPU_FEATURE(CPUFeature_TZCNT);       break;
  case 184:
 SET_CPU_FEATURE(CPUFeature_LZCNT);       break;
  case 185:

      instruction_begin -= 3;
      instruction_info_collected |= SPECIAL_INSTRUCTION;
      break;
  case 186:
current_state = 15; current_position++; goto _again;
  break;
  case 187:
current_state = 65; current_position++; goto _again;
  break;
  case 188:
current_state = 68; current_position++; goto _again;
  break;
  case 189:
current_state = 74; current_position++; goto _again;
  break;
  case 190:
current_state = 126; current_position++; goto _again;
  break;
  case 191:
current_state = 135; current_position++; goto _again;
  break;
  case 192:
current_state = 137; current_position++; goto _again;
  break;
  case 193:
current_state = 149; current_position++; goto _again;
  break;
  case 194:
current_state = 166; current_position++; goto _again;
  break;
  case 195:
current_state = 167; current_position++; goto _again;
  break;
  case 196:
current_state = 168; current_position++; goto _again;
  break;
  case 197:
current_state = 169; current_position++; goto _again;
  break;
  case 198:
current_state = 170; current_position++; goto _again;
  break;
  case 199:
current_state = 171; current_position++; goto _again;
  break;
  case 200:
current_state = 172; current_position++; goto _again;
  break;
  case 201:
current_state = 173; current_position++; goto _again;
  break;
  case 202:
current_state = 174; current_position++; goto _again;
  break;
  case 203:
current_state = 175; current_position++; goto _again;
  break;
  case 204:
current_state = 176; current_position++; goto _again;
  break;
  case 205:
current_state = 180; current_position++; goto _again;
  break;
  case 206:
current_state = 183; current_position++; goto _again;
  break;
  case 207:
current_state = 191; current_position++; goto _again;
  break;
  case 208:
current_state = 196; current_position++; goto _again;
  break;
  case 209:
current_state = 197; current_position++; goto _again;
  break;
  case 210:
current_state = 198; current_position++; goto _again;
  break;
  case 211:
current_state = 199; current_position++; goto _again;
  break;
  case 212:
current_state = 201; current_position++; goto _again;
  break;
  case 213:
current_state = 203; current_position++; goto _again;
  break;
  case 214:
current_state = 205; current_position++; goto _again;
  break;
  case 215:
current_state = 207; current_position++; goto _again;
  break;
  case 216:
current_state = 209; current_position++; goto _again;
  break;
  case 217:
current_state = 211; current_position++; goto _again;
  break;
  case 218:
current_state = 213; current_position++; goto _again;
  break;
}
switch (_dfa_transitions[current_state][*current_position][1]) {
  case 0:
  break;
  case 1:
current_state = 214; current_position++; goto _again;
  break;
  case 2:
current_state = 4; current_position++; goto _again;
  break;
  case 3:
current_state = 5; current_position++; goto _again;
  break;
  case 4:
current_state = 6; current_position++; goto _again;
  break;
  case 5:
 
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 214; current_position++; goto _again;
  break;
  case 6:
current_state = 12; current_position++; goto _again;
  break;
  case 7:
current_state = 13; current_position++; goto _again;
  break;
  case 8:
current_state = 14; current_position++; goto _again;
  break;
  case 9:

    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 214; current_position++; goto _again;
  break;
  case 10:
current_state = 2; current_position++; goto _again;
  break;
  case 11:
current_state = 3; current_position++; goto _again;
  break;
  case 12:
current_state = 7; current_position++; goto _again;
  break;
  case 13:
current_state = 8; current_position++; goto _again;
  break;
  case 14:
current_state = 9; current_position++; goto _again;
  break;
  case 15:
 SET_CPU_FEATURE(CPUFeature_E3DNOW);     
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 214; current_position++; goto _again;
  break;
  case 16:
 SET_CPU_FEATURE(CPUFeature_3DNOW);      
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 214; current_position++; goto _again;
  break;
  case 17:
current_state = 22; current_position++; goto _again;
  break;
  case 18:
current_state = 23; current_position++; goto _again;
  break;
  case 19:
current_state = 24; current_position++; goto _again;
  break;
  case 20:
 current_state = 19; current_position++; goto _again;
  break;
  case 21:
current_state = 10; current_position++; goto _again;
  break;
  case 22:
current_state = 39; current_position++; goto _again;
  break;
  case 23:
current_state = 40; current_position++; goto _again;
  break;
  case 24:
current_state = 44; current_position++; goto _again;
  break;
  case 25:
current_state = 45; current_position++; goto _again;
  break;
  case 26:
current_state = 46; current_position++; goto _again;
  break;
  case 27:
current_state = 41; current_position++; goto _again;
  break;
  case 28:
current_state = 42; current_position++; goto _again;
  break;
  case 29:
current_state = 43; current_position++; goto _again;
  break;
  case 30:
 current_state = 10; current_position++; goto _again;
  break;
  case 31:
current_state = 53; current_position++; goto _again;
  break;
  case 32:
current_state = 54; current_position++; goto _again;
  break;
  case 33:
current_state = 55; current_position++; goto _again;
  break;
  case 34:
current_state = 76; current_position++; goto _again;
  break;
  case 35:
current_state = 109; current_position++; goto _again;
  break;
  case 36:
current_state = 110; current_position++; goto _again;
  break;
  case 37:
current_state = 111; current_position++; goto _again;
  break;
  case 38:
 current_state = 75; current_position++; goto _again;
  break;
  case 39:
current_state = 129; current_position++; goto _again;
  break;
  case 40:
current_state = 130; current_position++; goto _again;
  break;
  case 41:
current_state = 131; current_position++; goto _again;
  break;
  case 42:
 current_state = 11; current_position++; goto _again;
  break;
  case 43:
 
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 215; current_position++; goto _again;
  break;
  case 44:
current_state = 139; current_position++; goto _again;
  break;
  case 45:
current_state = 142; current_position++; goto _again;
  break;
  case 46:
current_state = 145; current_position++; goto _again;
  break;
  case 47:
current_state = 147; current_position++; goto _again;
  break;
  case 48:
current_state = 11; current_position++; goto _again;
  break;
  case 49:
current_state = 127; current_position++; goto _again;
  break;
  case 50:
current_state = 128; current_position++; goto _again;
  break;
  case 51:
current_state = 132; current_position++; goto _again;
  break;
  case 52:
current_state = 133; current_position++; goto _again;
  break;
  case 53:
current_state = 134; current_position++; goto _again;
  break;
  case 54:
current_state = 151; current_position++; goto _again;
  break;
  case 55:
current_state = 154; current_position++; goto _again;
  break;
  case 56:
current_state = 156; current_position++; goto _again;
  break;
  case 57:
current_state = 158; current_position++; goto _again;
  break;
  case 58:
current_state = 160; current_position++; goto _again;
  break;
  case 59:
current_state = 163; current_position++; goto _again;
  break;
  case 60:
current_state = 165; current_position++; goto _again;
  break;
  case 61:
current_state = 177; current_position++; goto _again;
  break;
  case 62:
current_state = 178; current_position++; goto _again;
  break;
  case 63:
current_state = 179; current_position++; goto _again;
  break;
  case 64:
 
      if (((current_position - codeblock) & kBundleMask) != kBundleMask)
        instruction_info_collected |= BAD_CALL_ALIGNMENT;
     
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 214; current_position++; goto _again;
  break;
  case 65:
current_state = 188; current_position++; goto _again;
  break;
  case 66:
 current_state = 189; current_position++; goto _again;
  break;
  case 67:

      if (((current_position - codeblock) & kBundleMask) != kBundleMask)
        instruction_info_collected |= BAD_CALL_ALIGNMENT;
     
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 214; current_position++; goto _again;
  break;
  case 68:
 
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 216; current_position++; goto _again;
  break;
  case 69:
 
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 217; current_position++; goto _again;
  break;
  case 70:
 
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 218; current_position++; goto _again;
  break;
  case 71:
 
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 219; current_position++; goto _again;
  break;
  case 72:
 
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 220; current_position++; goto _again;
  break;
  case 73:
 
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 221; current_position++; goto _again;
  break;
  case 74:
 
    /* Mark start of this instruction as a valid target for jump.  */
    MarkValidJumpTarget(instruction_begin - codeblock, valid_targets);

    /* Call user-supplied callback.  */
    instruction_end = current_position + 1;
    if ((instruction_info_collected & VALIDATION_ERRORS_MASK) ||
        (options & CALL_USER_CALLBACK_ON_EACH_INSTRUCTION)) {
      result &= user_callback(instruction_begin, instruction_end,
                              instruction_info_collected, callback_data);
    }

    /*
     * We may set instruction_begin at the first byte of the instruction instead
     * of here but in the case of incorrect one byte instructions user callback
     * may be called before instruction_begin is set.
     */
    instruction_begin = instruction_end;

    /* Clear variables (well, one variable currently).  */
    instruction_info_collected = 0;
   current_state = 222; current_position++; goto _again;
  break;
}
_done: ;
  }

  /*
   * Check the direct jumps.  All the targets from jump_dests must be in
   * valid_targets.
   */
  result &= ProcessInvalidJumpTargets(codeblock,
                                      size,
                                      valid_targets,
                                      jump_dests,
                                      user_callback,
                                      callback_data);

  /* We only use malloc for a large code sequences  */
  if (jump_dests != &jump_dests_small) free(jump_dests);
  if (valid_targets != &valid_targets_small) free(valid_targets);
  if (!result) errno = EINVAL;
  return result;
}
